/* Send and Receive ASCII command from a i7k/i8k/i87k modules via serial port.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 April 2005 by Moki Matsushima
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <string.h>
#include "msw.h"
#include "xvboard.h"
#include "i7000.h"

void	usage(void);

int main(int argc, char **argv)
{
	int RetValue, comport=ttySA0, timeout=100, addr, count=1;
	char szBuf[80];
	DWORD baudrate=115200, dwValue_hi, dwValue_lo, mname;
	WORD wT;

	/* open device file */
	RetValue = Open_Com(comport, baudrate, Data8Bit, NonParity, OneStopBit);
	if (RetValue >0) {
		printf("open /dev/ttySA0 failed!\n");
		return FAILURE;
	}

	//get module name(low word) from XV Board
	memset(szBuf, 0, sizeof(szBuf));
	addr = 0x1e2;
	RetValue = getXVRegBack(comport, addr, count, szBuf, sizeof(szBuf));
	if (RetValue == 0) {
		dwValue_lo = (szBuf[0]<<8)|szBuf[1];
		//printf("0x%04x\n", dwValue_lo);
		mname = dwValue_lo;
	} else if (RetValue == CmdError) {
		printf("XV-Board return error code %d !!!\n", szBuf[0]);
		return FAILURE;
	} else {
		printf("XV-Board error %d !!!\n", RetValue);
		return FAILURE;
	}
	
	//get module name(high word) from XV Board
	memset(szBuf, 0, sizeof(szBuf));
	addr = 0x1e3;
	RetValue = getXVRegBack(comport, addr, count, szBuf, sizeof(szBuf));
	if (RetValue == 0) {
		dwValue_hi = (szBuf[0]<<8)|szBuf[1];
		//printf("0x%04x\n", dwValue_hi);
		mname = (dwValue_hi << 16) | mname;
	} else if (RetValue == CmdError) {
		printf("XV-Board return error code %d !!!\n", szBuf[0]);
		return FAILURE;
	} else {
		printf("XV-Board error %d !!!\n", RetValue);
		return FAILURE;
	}

	Close_Com(comport);

	printf("module name = 0x%08x\n", mname);

	return NoError;
}

void usage(void)
{
	printf("ICPDAS iTalk utility\n");
	printf("function : module_name\n");
	printf("Get module's name from a xv module's holding regsiter\n");
	printf("Usage: module_name\n");
	printf("Example 1:module_name\n");
	printf("Get the module's name from the xv module\n");
}
