/* Send and Receive ASCII command from a i7k/i8k/i87k modules via serial port.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 April 2016 by Moki Matsushima
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <string.h>
#include "msw.h"
#include "xvboard.h"
#include "i7000.h"

void	usage(void);

int main(int argc, char **argv)
{
	int RetValue, comport=ttySA0, timeout=100, addr, count;
	char szBuf[80];
	DWORD baudrate=115200, dwValue;
	WORD wT;
	if (argc == 4) {
		addr = atoi(argv[1]);
		count = atoi(argv[2]);
		dwValue = atol(argv[3]);
	}
	else {
		usage();
		return FAILURE;
	}
	/* open device file */
	RetValue = Open_Com(comport, baudrate, Data8Bit, NonParity, OneStopBit);
	if (RetValue >0) {
		printf("open /dev/ttySA0 failed!\n");
		return FAILURE;
	}
	memset(szBuf, 0, sizeof(szBuf));

	szBuf[0] = dwValue & 0xff;
	szBuf[1] = (dwValue>>8) & 0xff;
	szBuf[2] = (dwValue>>16) & 0xff;
	szBuf[3] = (dwValue>>24) & 0xff;
	RetValue = setXVBit(comport, addr, count, szBuf, sizeof(szBuf));
	Close_Com(comport);
	if (RetValue == 0) {
	} else if (RetValue == CmdError) {
		printf("XV-Board return error code %d !!!\n", szBuf[0]);
		return FAILURE;
	} else {
		printf("XV-Board error %d !!!\n", RetValue);
		return FAILURE;
	}
	return NoError;
}

void usage(void)
{
	printf("ICPDAS iTalk utility\n");
	printf("function : setxvdo\n");
	printf("Set digital output value from a xv module\n");
	printf("Module XV311, 4 DO cheannl, DO0 address 0x0\n");
	printf("Usage: setxvdo addr count value\n");
	printf("Example 1:setxvdo 1 2 3\n");
	printf("Set the dec digital output value 3 from the xv module at addr 1~2\n");
	printf("Example 2:setxvdo 2 3 5\n");
	printf("Set the dec digital output value 5 from the xv module at addr 2~4\n");
}
